#define LATEST_IBM	"2.1"
#define LATEST_UNIX	"3.0"
#define LATEST_XWIN	"3.7"
#define LATEST_AMIGA	"1.2"
#define LATEST_DOS	"1.1"
#define LATEST_MAC      "1.0"
#define LOC		"/doc/old/OLD_"
/* Patched(Rewritten?) by BAN 931008 to handle homemade clients with
   version no greater than the defined */

mapping latest;

mapping filename;

int ge(string str1,string str2) /* Returns true if str1 >= str2 */
{
  if (str1[0]<str2[0]) return 0;
  if (str1[0]==str2[0] && str1[2]<str2[2]) return 0;
  return 1;
}
version_check(string ver) {
  string versno,name;
  latest = ([ "AMIG ":LATEST_AMIGA, "IBM  ":LATEST_IBM, 
	     "XWIN ":LATEST_XWIN,  "UNIX ":LATEST_UNIX,
	     "DOS  ":LATEST_DOS, " MAC ":LATEST_MAC]);
  filename = (["AMIG ":"AMIGA", "IBM  ":"IBM", "XWIN ":"XWIN",
	       "UNIX ":"UNIX", "DOS  ":"DOS", " MAC ","MAC"]);
  versno=extract( ver, 5, 7 );
  name=extract( ver, 0, 4  );
  if (!latest[name]) cat(LOC+"CLIENT");
  else
    {
      if (!ge(versno,latest[name])) cat(LOC+filename[name]);
    }
}
