/* bugs (a lot :) fixed by Orion 8th April 1992 */
/* pre- and postfix added by Peugh */
inherit "room/xroom.c";
#include "/system/sendhex.h"

int departure=0;
int stage;
object passenger;
string destination;

int lenpre=0;
int lenpost=0;

string *prefix;
string *postfix;


reset(arg) {
  string tmp,instance;
  ::reset(arg);
    description = "You are at an arrival/departure bay for space cabs.\n"+
      "type 'go <PLANET>' to use one.\n";
  if (!departure) {
    set_heart_beat(1);
    tmp = file_name(this_object());
    sscanf(tmp,"%s#%s",idstr,instance);
  }
}

init() {
  ::init();
  add_action("go","go");
  add_action("noway2","look");
  add_action("noway2","l");
}

set_prefix(string *_prefix)
{
   prefix = _prefix;
   lenpre = sizeof(_prefix);
}

set_postfix(string *_postfix)
{
   postfix = _postfix;
   lenpost = sizeof(_postfix);
}
  
hjart_slag() {
  if (!departure)
    return;
  if (!passenger) { 
    /* Fix bug that freezes cab service when players quit mid-travel */
    departure = 0;
    return;
  }
  stage++;
  if (stage < (lenpre + lenpost + 13)) call_out("hjart_slag",1);
  if (stage<6) {
    gfx_tell_room(this_object(),"@"+"RMOroom/cab/ship.@"+
		  "VIOroom/cab/ship."+sendhex(7+stage)+"00@RFS");
      if (stage==1) 
	nogfx_tell_object(passenger,"The cab is accellerating.");
      else 
	nogfx_tell_object(passenger,"..");
    return;
  }
  if (stage == 6) { 
    gfx_tell_room(this_object(),"@"+"RMOroom/cab/ship.@RFS");
    nogfx_tell_object(passenger,"..");
 /*    say("@"+"RMOroom/cab/ship.@"+"RFS"); */
  }
  
  if (stage < lenpre + 6) {
      gfx_tell_object(passenger, "@"+"SCE"+prefix[stage - 6]+".@"+"RFS");
      nogfx_tell_object(passenger,"..");
    return;
  }
    
  if (stage==(lenpre + 6)) {
      gfx_tell_object(passenger,"@"+"SCEroom/cab/inspace.@"+"RFS");
      nogfx_tell_object(passenger,"..");
    return;
  }
  if ((stage>(lenpre + 8)) && (stage<(lenpre + lenpost + 9))) {
      gfx_tell_object(passenger, "@"+"SCE"+postfix[stage - lenpre - 9]+".@"+"RFS");
      nogfx_tell_object(passenger,"..");
    return;
  }

  if ((stage == (lenpre + lenpost + 9))) {
    nogfx_tell_object(passenger,"\nYou arrive.\n");
    move_object(passenger,destination);
    destination->resend_state();
    command("look",passenger);
    tell_object(passenger,"> ");
    return;
  }
  if (stage >= (lenpre + lenpost + 13)) {
    departure = 0;
    passenger = 0;
    say("A new cab arrives.\n");
    gfx_tell_room(this_object(),"@"+"VIOroom/cab/ship.0700@"+"RFS");
    return;
  }
}

long() {
  ::long();
  if (!departure) 
  gfx_write("@"+"VIOroom/cab/ship.0700@"+"RFS");
}

go(str) {
  if (!str) {
    write ("Where do you want to go?\n");
    return 1;
  }
  if (departure)
    if (passenger != this_player()) {
      write("Please wait for "+passenger->query_name()+".\n");
      return 1;
    } else {
      write("Too late, you are already destined for a planet.\n");
      return 1;
    }
  destination = service(str);
  if (!destination) {
    write("Sorry, the space cabs do not service planet "+str+"\n");
    return 1;
  }
  write("You are on your way to "+((str=="moon")?"the moon":str)+".\n");
  passenger = this_player();
  departure = 1;
  stage = 0;
  gfx_tell_room(this_object(),"@"+"RMO"+passenger->query_idstr()+".@"+"RFS");
  add_action("noway","micro_w");
  add_action("noway","micro_n");
  add_action("noway","micro_s");
  add_action("noway","micro_e");
  add_action("noway","look");
  add_action("noway","l");
  call_out("hjart_slag",1);
  return 1; 
}

noway() {
        return 1;
}
noway2(str) {
        if(!str) {
                if(departure) return 1;
        }
}
