#define LATEST_IBM	"2.1"
#define LATEST_UNIX	"3.0"
#define LATEST_XWIN	"3.7"
#define LATEST_AMIGA	"1.2"
#define LATEST_DOS	"1.1"
#define LOC		"/doc/old/OLD_"
 
/* Patched(Rewritten?) by BAN 931008 to handle homemade clients with
   version no greater than the defined */
 
/* Patched by Sam 931124 to handle a PC client from ftp.math.okstate.edu
   in /pub/muds/BSXstuff which send 'MSDOS 2.1' as its version, weird... */
 
mapping latest;
 
mapping filename;
 
int ge(string str1,string str2) /* Returns true if str1 >= str2 */
{
  if (str1[0]<str2[0]) return 0;
  if (str1[0]==str2[0] && str1[2]<str2[2]) return 0;
  return 1;
}
 
string version_check(string ver) {
  string versno,name;
  latest = ([ "AMIG ":LATEST_AMIGA, "IBM  ":LATEST_IBM, 
	     "XWIN ":LATEST_XWIN,  "UNIX ":LATEST_UNIX,
	     "DOS  ":LATEST_DOS]);
  filename = (["AMIG ":"AMIGA", "IBM  ":"IBM", "XWIN ":"XWIN",
	       "UNIX ":"UNIX", "DOS  ":"DOS"]);
 

  /* Patch -> Test if the name is 'MSDOS' (Sam) */
  if (extract(ver,0,5) == "MSDOS ") {
    name = "IBM  ";
    versno=extract( ver, 6, 8 );
  }
  /* End Patch (Sam) */
  else {
    name=extract( ver, 0, 4);
    versno=extract( ver, 5, 7 );
  }

  if (!latest[name]) cat(LOC+"CLIENT");
  else
    {
      if (!ge(versno,latest[name])) cat(LOC+filename[name]);
    }

  return (name+versno);
}
